//
// BrackStack.cpp -    ,  
//  .
//         q-:
//
// 1. S -> (B)B
// 2. B -> (B)B
// 3. B -> empty
//

#include <iostream>
#include <string>
#include <vector>
#include <stack>

using namespace std;

//     S, B,   (botoom).
//        .
enum stackSymb {S = 256, B, bottom}; 

string str;	//    ,   
int i;	//    

stack <int, vector<int> > stck; //    

// ,        .
//       .
//       Enter.
//  '\n'     .
void GetOneLine(istream &is, string &str) {
	char ch;
	str = "";
	for(;;) {
		is.get(ch);
		if(is.fail() || ch == '\n') break;
		str += ch;
	}
	str += '\n'; //   
}

//   
void Init() {
	//  
	while(!stck.empty()) 
		stck.pop();
	stck.push(bottom);
	stck.push(S);

	//   
	i = 0;
}

//   ,   .
//    .
bool Parser() {
	//   
	Init();

	int step = 0;
	//   
	for(;;) {
		//      ,  ,  
		cout<<"step " << step++ << ": str[" << i << "] = "<< str[i] 
			<< " Top = "<< stck.top() << "\n";
		//     
		switch(stck.top()) {
			//     
			case S:
			switch(str[i]) {
				case '(': // [S, (]
					stck.top() = B; //  stck.pop(); stck.push(B);
					stck.push(')');
					stck.push(B);
					i++; //   
					break;
				case ')': // [S, )] - )     
					cout  << "Position " << i << ", "
						<< "Error 1: \')\' can not is in begin!\n";
					return false;
				case '\n': // [S,  ]
					cout  << "Position " << i << ", "
						<< "Error 2: Empty string!\n";
					return false;
				default: // ,    
					cout  << "Position " << i << ", "
						<< "Incorrect symbol! " << str[i] << "\n";
					return false;
			}
			break;

			//     
			case B:
			switch(str[i]) {
				case '(': // [B, (]
					stck.top() = B; //  stck.pop(); stck.push(B);
					stck.push(')');
					stck.push(B);
					i++; //   
					break;
				case ')': // [B, )] -    
					stck.pop();
					break;
				case '\n': // [B,  ] -   
					stck.pop();
					break;
				default: // ,    
					cout  << "Position " << i << ", "
						<< "Incorrect symbol! " << str[i] << "\n";
					return false;
			}
			break;

			case ')':
			//     
			switch(str[i]) {
				case '(': // [), (] -   
					cout  << "Position " << i << ", "
						<< "Error 3: I want \')\'!\n";
					return false;
				case ')': // [), )] -    
					stck.pop(); // 
					i++;		// 
					break;
				case '\n': // [),  ]
					cout  << "Position " << i << ", "
						<< "Error 4: I want \')\'!\n";
					return false;
				default: // ,    
					cout  << "Position " << i << ", "
						<< "Incorrect symbol! " << str[i] << "\n";
					return false;
			}		
			break;

			//     
			case bottom:
			switch(str[i]) {
				case '(': // [bottom, (] -    
					cout  << "Position " << i << ", "
						<< "Error 4: Impossible situation [bottom, \'(\']!\n";
					return false;
				case ')': // [bottom, )] -  )
					cout  << "Position " << i << ", "
						<< "Error 5: unnecessary \')\'!\n";
					return false;
				case '\n': // [bottom,  ] - !
					return true;
				default: // ,    
					cout  << "Position " << i << ", "
						<< "Incorrect symbol! " << str[i] << "\n";
					return false;
			}		
			break;
		}
	}

}

//       
//         ,   
//    
int main () {
	string strCursor;
	str = "";
	//     
	do {
		//      
		cout << "Input bracket\'s expression!: ";

		//      .
		GetOneLine(cin, str);

		//     .
		if(Parser())
			cout << "+++++ OK! +++++\n";
		else
			cout << "----- Fatal error (look upper error message)! -----\n";

		//        .
		cout << "Line: " << str;
		strCursor = " Pos: " + string(i, '-');
		strCursor +='^';
		cout << strCursor << "  i = " << i << "\n\n";

	} while(str != "\n");
	cout << "Goodbye!\n";
	return 1;
}